/*
 * $Id: paletteprefs.c,v 1.1.1.1 2005/03/15 16:01:01 laire Exp $
 */
#define AROS_ALMOST_COMPATIBLE
#include "global.h"
#include <proto/iffparse.h>
#include <aros/asmcall.h>

#define DEBUG 0
#include <aros/debug.h>

struct IOldPenPrefs
{
	UWORD Count;
	UWORD Type;
	ULONG Pad;
	UWORD PenTable[32+1];
};

AROS_UFH1(LONG, PalettePrefs_Handler,
		  AROS_UFHA(struct IFFHandle *, iff, A2))
{
	AROS_LIBFUNC_INIT

	struct PalettePrefs iprefs;
	struct IOldPenPrefs	penprefs;

	D(bug("IPrefs: PalettePrefs\n"));

	if (ReadChunkBytes(iff, &iprefs, sizeof(iprefs)) == sizeof(iprefs))
	{
		/* 4 Colours */
		penprefs.Count		=	32+1;
		penprefs.Type		=	0;
		penprefs.Pad		=	0;
		CopyMem(&iprefs.pap_4ColorPens[0],
		        &penprefs.PenTable[0],
		        sizeof(penprefs.PenTable));
		penprefs.PenTable[32+1]	=	-1;
		SetIPrefs(&penprefs, sizeof(penprefs), IP_PENS);

		/* 8 Colours */
		penprefs.Count		=	32+1;
		penprefs.Type		=	1;
		penprefs.Pad		=	0;
		CopyMem(&iprefs.pap_8ColorPens[0],
		        &penprefs.PenTable[0],
		        sizeof(penprefs.PenTable));
		penprefs.PenTable[32+1]	=	-1;
		SetIPrefs(&penprefs, sizeof(penprefs), IP_PENS);

		SetIPrefs(&iprefs.pap_Colors[0], sizeof(iprefs.pap_Colors), IP_PALETTE);
	}

	return 0;

	AROS_LIBFUNC_EXIT
}
